angular.module('ufind1.controllers')

    .controller('mainCtrl', function ($rootScope, $scope, $state, $timeout, $interval, $translate, $ionicHistory, $location,$stateParams, $ionicLoading,
                                      $ionicPlatform, $ionicSlideBoxDelegate, bleService, deviceService, itemService, systemService, geoLocationService,locationService) {
        var deviceId = $stateParams.deviceId;
        var timerAnimation = null;
        var sys_tem = systemService.deserialize();
        var currentPlatform = ionic.Platform.platform();


        $scope.is_masked = false;
        function is_show(a){
            if(sys_tem.booleanFirst == 2){
                $scope.is_masked =true ;
            }
        }
        $scope.isShow = function(){
            var sys_t = systemService.all();
            $scope.is_masked = false;
            sys_t.booleanFirst =3;
            systemService.serialize();

        }
        $scope.text_color ="#fff"
        $scope.openUrl = function () {
            if (currentPlatform == "android" || currentPlatform == "ios")
                window.open('https://shop35240171.taobao.com/', '_blank', 'location=no');
        };
        $scope.onClickMain = function () {
            $state.go("main");
        };


        var startProbeRSSI = function (item) {

            if (typeof(item.timerRSSI) != "undefined" && item.timerRSSI != null) {
                $interval.cancel(item.timerRSSI);
            }

            item.timerRSSI = $interval(function myFunction() {
                bleService.getRSSI(item.id).then(function (result) {
                    item.rssi = result;
                    if (result > -75) {
                        item.signal = "img/ble_signal_5.png";
                    } else if (result > -80) {
                        item.signal = "img/ble_signal_4.png";
                    } else if (result > -85) {
                        item.signal = "img/ble_signal_3.png";
                    } else if (result > -95) {
                        item.signal = "img/ble_signal_2.png";
                    }else {
                        item.signal = "img/ble_signal_1.png";
                    }
                }, function (error) {
                    console.log("GetRSSI Failed:", error);
                });
            }, 5 * 1000);
        };
        var startProbeRSSI2 = function (item) {
            $scope.i=1;
            if (typeof(item.timerRSSI) != "undefined" && item.timerRSSI != null) {
                $interval.cancel(item.timerRSSI);
            }
            item.timerRSSI = $interval(function myFunction() {
                if ($scope.i == 1) {
//                    console.log("1    ", $scope.i);
                    $scope.i=2;
                    item.signal = "img/ble_animation_1.png";
                } else if ($scope.i == 2) {
                    item.signal = "img/ble_animation_2.png";
//                    console.log("2    ", $scope.i);
                    $scope.i=3;
                } else if ($scope.i == 3) {
                    item.signal = "img/ble_animation_3.png";
//                    console.log("3    ", $scope.i);
                    $scope.i=4;
                } else if ($scope.i == 4) {
                    item.signal = "img/ble_animation_4.png";
//                    console.log("4    ", $scope.i);
                    $scope.i = 5;
                }else {
                    item.signal = "img/ble_animation_5.png";
//                    console.log("5    ", $scope.i);
                    $scope.i=1;
                }
            }, 1000);
        };

        $scope.$on('$ionicView.afterEnter', function () {
            $ionicHistory.clearHistory();
            $ionicHistory.clearCache();
        });

        var currentPlatform = ionic.Platform.platform();
        if (currentPlatform == "android") {
            $ionicPlatform.registerBackButtonAction(function (e) {
                if ($location.path() == '/') {
                    bleService.isConnected("");
                } else if ($ionicHistory.backView()) {
                    $ionicHistory.goBack();

                } else {
                    bleService.isConnected("");
                }
            }, 101);
        }
        $rootScope.onConnected = function (device) {
            is_show(sys_tem.booleanFirst);


            var item = itemService.get(device.id);
            if (item == null) {
                item = new Object();
                item.id = device.id;
                item.name = device.name;
                if(item.name == "" || item.name == undefined || item.name == null ){
                    item.name="未命名";
                    console.log("000111      "+item.name);
                }
                item.imageURI = device.imageURI;
                itemService.add(item);
            }
            $scope.text_color ="#fff";
            item.color = $scope.text_color;
            item.statusImage = "staticImage";
            item.prefix = "find";
            item.status = "connect";
            item.suffix = "";
            item.signal = "img/ble_signal_1.png";
            startProbeRSSI(item);
        };

        Date.prototype.Format = function (fmt) { //author: meizz
            var o = {
                "M+": this.getMonth() + 1, //月份
                "d+": this.getDate(), //日
                "h+": this.getHours(), //小时
                "m+": this.getMinutes(), //分
                "s+": this.getSeconds(), //秒
                "q+": Math.floor((this.getMonth() + 3) / 3), //季度
                "S": this.getMilliseconds() //毫秒
            };
            if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
            for (var k in o)
                if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
            return fmt;
        }

        $rootScope.onDisconnected = function (device) {
            var item = itemService.get(device.id);
            console.log("item disconnected: " + JSON.stringify(item));
            item.statusImage = "flashImage";
            item.prefix = "wait";
            item.status = "dis_connect";
            item.suffix = "re_connect";
            item.signal = "img/ble_signal_0.png";
            $scope.text_color ="#c94b55";
            item.color= $scope.text_color;
            $rootScope.$broadcast('devices.refresh', null);

            if (item.timerRSSI != null) {
                $interval.cancel(item.timerRSSI);
                item.timerRSSI = null;
            }
            console.log("main 181:  sys_tem.booleanConnectSignal     "+sys_tem.booleanConnectSignal);
            sys_tem.booleanConnectSignal=3;
            systemService.serialize();
            startProbeRSSI2(item);
            var tmp = device.alertTime.substr(0, device.alertTime.length - 1);
            var intAlertTime = parseInt(tmp);
            timerAnimation = $timeout(function myFunction() {
                item.statusImage = "staticImage";
                $rootScope.$broadcast('devices.refresh', null);
            }, intAlertTime * 1000);

            if (typeof(geoLocationService) != "undefined") {
                geoLocationService.getCurrentPosition({
                        timeout: 10000,
                        enableHighAccuracy: false
                    })
                    .then(function (position) {
                        var long = position.coords.longitude;
                        var lat = position.coords.latitude;
                        var time = new Date().Format("yyyy-MM-dd hh:mm");
                        console.log("gps定位 longitude = " + long + " ,latitude = " + lat);
                        locationService.setPos(lat, long);
                        locationService.setTime(time);
                        locationService.setIsBaiduPoint(false);
                        device.lati = lat;
                        device.lon = long;
                        device.time = time;
                        device.isBaiduPoint = false;
                        deviceService.serialize();
                    }, function (err) {
                        if(BMap.Geolocation && typeof(BMap.Geolocation) == "function") {
                            var baiduGeolocation = new BMap.Geolocation();
                            baiduGeolocation.getCurrentPosition(function (r) {
                                if (this.getStatus() == BMAP_STATUS_SUCCESS) {
                                    var long = r.point.lng;
                                    var lat = r.point.lat;
                                    var time = new Date().Format("yyyy-MM-dd hh:mm");
                                    console.log("百度地图定位 longitude = " + long + " ,latitude = " + lat);
                                    locationService.setPos(lat, long);
                                    locationService.setTime(time);
                                    locationService.setIsBaiduPoint(true);
                                    device.lati = lat;
                                    device.lon = long;
                                    device.time = time;
                                    device.isBaiduPoint = true;
                                    deviceService.serialize();
                                }
                                else {
                                    console.log('failed' + this.getStatus());
                                }
                            }, {enableHighAccuracy: true});
                        }
                        console.log("unable to find gps location");
                        $scope.errorMsg = "Error : " + err.message;
                    });
            }
        };
        var system = systemService.deserialize();
        if (system.language != null) {
            $translate.use(system.language);
        }


        $translate.use(getSystemLanguage());

        function getSystemLanguage() {
            if (system.language == null) {
                var language = navigator.language;
                var zh_patt = new RegExp(/^zh-[a-zA-Z]*/);
                if (zh_patt.test(language))
                    return "chs";
                else
                    return "en";
            }
            else
                return system.language;
        }

        var devices = deviceService.deserialize();

        for (var i = 0; i < devices.length; i++) {
            var item = new Object();
            item.id = devices[i].id;
            item.name = devices[i].name;
            item.imageURI = devices[i].imageURI;
            item.signal = "img/ble_signal_0.png";
            //未连接状态的动画
            item.timerRSSI = $interval(function myFunction() {
                bleService.getRSSI(item.id).then(function (result) {
                    item.rssi = result;
                    if (result > -75) {
                        item.signal = "img/ble_signal_5.png";
                    } else if (result > -80) {
                        item.signal = "img/ble_signal_4.png";
                    } else if (result > -85) {
                        item.signal = "img/ble_signal_3.png";
                    } else if (result > -95) {
                        item.signal = "img/ble_signal_2.png";
                    }else {
                        item.signal = "img/ble_signal_1.png";
                    }
                }, function (error) {
                    console.log("connecterror: " + JSON.stringify(error));
                    startProbeRSSI2(item);
                });
            }, 1000);
            itemService.add(item);
        }


        if (currentPlatform == "android"){
            $scope.times=1;
            var xx = 0;
            var connectDevice = function (dev) {
//            if (typeof(dev) == "undefined" || !dev.id) {
//                break;
//            }
                //兼容以前的版本
                if(typeof(dev.alertRange) == "undefined") {
                    dev.alertRange = "3";
                    deviceService.serialize();
                }

                bleService.setOption(dev.id, "cmdAlertRange", dev.alertRange);
                bleService.setOption(dev.id, "cmdAppAlert", dev.appAlert ? "1" : "0");
                bleService.setOption(dev.id, "cmdAlertTime", dev.alertTime);
                bleService.setOption(dev.id, "cmdReconnectAlert", dev.reconnectAlert ? "1" : "0");
                bleService.setOption(dev.id, "cmdItemAlert", dev.itemAlert ? "1" : "0");

                console.log("main27 $scope.times    "+$scope.times);
                bleService.dataRefresh(dev.id, "WaitdeviceConnect",1).then(function (result) {
                    console.log("cmdHeart1---->" + JSON.stringify(result));
                }, function (result) {
                    console.log("cmdHeart2---->" + JSON.stringify(result));
                }, function (result) {
                    console.log("cmdHeart3---->" + JSON.stringify(result));
                    $scope.tempValue=result.ok;
                    console.log(" $scope.tempValue---->"+$scope.tempValue);
                    if($scope.tempValue  ==  "ok"){
                        console.log("$scope.tempValue2     "+ $scope.tempValue);
                        bleService.scan_device_by_id(dev.id,20).then(function(success) {
                                bleService.connect(dev.id).promise.then(function (result) {
                                }, function (result) {
                                }, function (result) {
                                    if (result.status == "connected") {
                                        $scope.times=2;
                                        console.log("connected: " + JSON.stringify(result));
                                        $rootScope.onConnected(dev);
                                        $rootScope.$broadcast('devices.refresh', null);
                                        console.log("sys_tem.booleanFirst       " + sys_tem.booleanFirst);
                                        console.log("main289dev       " + dev);
                                        bleService.setOption(dev.id, "selfTakepicture", "0" + "" + dev.zeroButton);
                                        bleService.setOption(dev.id, "selfTakepicture", "1" + "" + dev.oneButton);
                                        bleService.setOption(dev.id, "selfTakepicture", "2" + "" + dev.twoButton);
                                        bleService.setOption(dev.id, "selfTakepicture", "3" + "" + dev.threeButton);
                                        bleService.setOption(dev.id, "selfTakepicture", "4" + "" + dev.fourButton);
                                        bleService.setOption(dev.id, "selfTakepicture", "5" + "" + dev.fiveButton);
                                        bleService.setOption(dev.id, "selfTakepicture", "6" + "" + dev.sixButton);
                                        bleService.setOption(dev.id, "selfTakepicture", "7" + "" + dev.sevenButton);
                                        bleService.setOption(dev.id, "selfTakepicture", "8" + "" + dev.eightButton);
                                        deviceService.serialize();
                                    } else if (result.status == "disconnected") {
                                        if (result.lose_water != null) {
                                            return;
                                        } else {
                                            console.log("disconnected: " + JSON.stringify(result));
                                            $rootScope.onDisconnected(dev);
                                        }
                                    }
                                    xx++;
                                    if(devices.length>xx){
                                        console.log("连接次数......." + xx);
                                        connectDevice(devices[devices.length-(devices.length-xx)]);
                                    }
                                });
                            },
                            function(failed) {
                                console.log("扫描未发现之前连接的设备。。。。");
                            });
                    }
                });
            };
        }else if (currentPlatform == "ios"){
            var connectDevice = function (dev) {
                bleService.connect(dev.id).promise.then(function (result) {
                }, function (result) {
                }, function (result) {
                    if (result.status == "connected") {
                        //连接的时候
                        console.log("connected: " + JSON.stringify(result));
                        $rootScope.onConnected(dev);
                        $rootScope.$broadcast('devices.refresh', null);
                        bleService.setOption("", "selfTakepicture", "0"+""+sys_tem.zeroButton);
                        bleService.setOption("", "selfTakepicture", "1"+""+sys_tem.oneButton);
                        bleService.setOption($stateParams.deviceId, "selfTakepicture", "2"+""+sys_tem.twoButton);
                        deviceService.serialize();
                    } else if (result.status == "disconnected") {
                        if (result.lose_water != null) {
                            return;
                        } else {
                            console.log("disconnected: " + JSON.stringify(result));
                            $rootScope.onDisconnected(dev);
                        }
                    }
                });
            };
        }



        $ionicPlatform.ready(function () {
            geoLocationService.getCurrentPosition({
                    timeout: 10000,
                    enableHighAccuracy: false
                })
                .then(function (position) {
                    var long = position.coords.longitude;
                    var lat = position.coords.latitude;
                    var time = new Date().Format("yyyy-MM-dd hh:mm");
                    locationService.setPos(lat, long);
                    locationService.setTime(time);
                    locationService.setIsBaiduPoint(false);
                }, function (err) {
                    if(BMap.Geolocation && typeof(BMap.Geolocation) == "function") {
                        var baiduGeolocation = new BMap.Geolocation();
                        baiduGeolocation.getCurrentPosition(function (r) {
                            if (this.getStatus() == BMAP_STATUS_SUCCESS) {
                                var long = r.point.lng;
                                var lat = r.point.lat;
                                var time = new Date().Format("yyyy-MM-dd hh:mm");
                                locationService.setPos(lat, long);
                                locationService.setTime(time);
                                locationService.setIsBaiduPoint(true);
                            }
                        }, {enableHighAccuracy: true});
                    } else {
                        console.log("load baidu map error");
                    }
                });
            bleService.setOption("", "cmdSilentArea", system.silentArea ? "1" : "0");
            bleService.setOption("", "cmdSilentArea1x0", system.silentArea1x0);
            bleService.setOption("", "cmdSilentArea1y0", system.silentArea1y0);
            bleService.setOption("", "cmdSilentArea1Radius", system.silentArea1Radius);

            bleService.setOption("", "cmdSilentArea2x0", system.silentArea2x0);
            bleService.setOption("", "cmdSilentArea2y0", system.silentArea2y0);
            bleService.setOption("", "cmdSilentArea2Radius", system.silentArea2Radius);
            bleService.setOption("", "cmdSilentArea3x0", system.silentArea3x0);
            bleService.setOption("", "cmdSilentArea3y0", system.silentArea3y0);
            bleService.setOption("", "cmdSilentArea3Radius", system.silentArea3Radius);

            bleService.setOption("", "cmdSilentWifi1", system.silentWifi1);
            bleService.setOption("", "cmdSilentWifi2", system.silentWifi2);
            bleService.setOption("", "cmdSilentWifi3", system.silentWifi3);

            bleService.setOption("", "cmdSilentTime", system.silentTime ? "1" : "0");
            bleService.setOption("", "cmdSilentStartHour1", system.silentStartHour1 == null ? "0" : system.silentStartHour1);
            bleService.setOption("", "cmdSilentStartMinute1", system.silentStartMinute1 == null ? "0" : system.silentStartMinute1);
            bleService.setOption("", "cmdSilentStopHour1", system.silentStopHour1 == null ? "0" : system.silentStopHour1);
            bleService.setOption("", "cmdSilentStopMinute1", system.silentStopMinute1 == null ? "0" : system.silentStopMinute1);
            bleService.setOption("", "cmdSilentWeekDay1", system.silentWeekDay1 == null ? "0" : system.silentWeekDay1);

            bleService.setOption("", "cmdSilentStartHour2", system.silentStartHour2 == null ? "0" : system.silentStartHour2);
            bleService.setOption("", "cmdSilentStartMinute2", system.silentStartMinute2 == null ? "0" : system.silentStartMinute2);
            bleService.setOption("", "cmdSilentStopHour2", system.silentStopHour2 == null ? "0" : system.silentStopHour2);
            bleService.setOption("", "cmdSilentStopMinute2", system.silentStopMinute2 == null ? "0" : system.silentStopMinute2);
            bleService.setOption("", "cmdSilentWeekDay2", system.silentWeekDay2 == null ? "0" : system.silentWeekDay2);


            devices = deviceService.all();
            if (currentPlatform == "android"){
                if(devices.length>0){
                    connectDevice(devices[0]);
                }
            }else if (currentPlatform == "ios"){
                for (var i = 0; i < devices.length; i++) {
                    var dev = devices[i];
                    if (typeof(dev) == "undefined" || !dev.id) {
                        break;
                    }
                    //兼容以前的版本
                    if(typeof(dev.alertRange) == "undefined") {
                        dev.alertRange = "3";
                        deviceService.serialize();
                    }

                    bleService.setOption(dev.id, "cmdAlertRange", dev.alertRange);
                    bleService.setOption(dev.id, "cmdAppAlert", dev.appAlert ? "1" : "0");
                    bleService.setOption(dev.id, "cmdAlertTime", dev.alertTime);
                    bleService.setOption(dev.id, "cmdReconnectAlert", dev.reconnectAlert ? "1" : "0");
                    bleService.setOption(dev.id, "cmdItemAlert", dev.itemAlert ? "1" : "0");
                    connectDevice(dev);
                }
            }

        });


        $scope.items = itemService.all();
        $scope.isAnyItems = $scope.items.length > 0;
        $scope.showBg = $scope.isAnyItems ? "" : "main";
        $scope.screen_width = document.body.clientWidth;

        $scope.onClickSetting = function () {
            $state.go("setting");
        };

        $scope.onClickSearch = function () {
            $state.go("search");
        };

        $scope.onClickConfig = function () {
            $state.go("config");
        };
        $rootScope.boole = function (item) {
            if(item.prefix == "wait"){
                return "";
            }else {
                return "myVar";
            }
        }
        $rootScope.$on('devices.refresh', function (event, device) {
            console.log("refresh device: " + JSON.stringify(device));
            if (device != null) {
                console.log("refreshed the item property!")
                var item = itemService.get(device.id);
                item.name = device.name;
                if(item.name == "" || item.name == undefined || item.name == null ){
                    item.name="未命名";
                }

                item.imageURI = device.imageURI;
            }
            $scope.items = itemService.all();
            $scope.isAnyItems = $scope.items.length > 0;
            $timeout(function() {
                $ionicSlideBoxDelegate.$getByHandle("main_slide_box").update();
            }, 500);
            $scope.showBg = $scope.isAnyItems ? "" : "main";
        });

        $scope.$on('$destroy', function () {
            var items = itemService.all();
            for (i in items) {
                if (typeof(i.timerRSSI) != null) {
                    $interval.cancel(i.timerRSSI);
                }
            }

            if (typeof(timerAnimation) != null) {
                $timeout.cancel(timerAnimation);
            }
        });

        $scope.onClickedLook = function (item) {
            $scope.isSend= 1;
            var array = new Uint8Array(1);
            array[0] = 1;
            if ($scope.isSend == 1) {
                $scope.isSend = 0;
                bleService.write(item.id, '1802', '2A06', array.buffer).then(function (result) {
                    item.prefix = result;
                    $scope.isSend = 1;
                });
            }


        }
    })
;