cordova.define("ustone-plugin-call.echoTest", function(require, exports, module) {
var exec = require('cordova/exec');

var echoTest = {
     getNetworks: function (successCallback, errorCallback) {
            exec(function (res) {
                networks = res.map(function (r) {
                    return new AccessPoint(r.BSSID, r.SSID, r.level);
                });
            }, function (e) {
                errorCallback(e);
            }, "Plugin_intent", "getNetworks", []);
        },
	getSmsworks: function (successCallback) {
            exec(function (res) {
                networks = res.map(function (r) {
                    return new AccessPoint(r.BSSID, r.SSID, r.level);
                });
            }, function (e) {
                errorCallback(e);
            }, "Plugin_intent", "getSmsworks", []);
        },
	getCallworks: function (errorCallback) {
            exec(function (res) {
                networks = res.map(function (r) {
                    return new AccessPoint(r.BSSID, r.SSID, r.level);
                });
            }, function (e) {
                errorCallback(e);
            }, "Plugin_intent", "getCallworks", []);
        },
	getVirtualCallworks: function () {
            exec(function (res) {
                networks = res.map(function (r) {
                    return new AccessPoint(r.BSSID, r.SSID, r.level);
                });
            }, function (e) {
                errorCallback(e);
            }, "Plugin_intent", "getVirtualCallworks", []);
        }

};
module.exports = echoTest;

});
