angular.module('ufind1.controllers')

    .controller('alertCtrl', function ($scope,$state, $stateParams, deviceService, bleService) {
        var device = deviceService.get($stateParams.deviceId);
        var currentPlatform = ionic.Platform.platform();
        $scope.device = device;
        
        $scope.onClickAppAlert = function () {
            if (currentPlatform == 'ios' || currentPlatform == 'android') {
                bleService.setOption($scope.device.id, "cmdAppAlert", $scope.device.appAlert ? "1" : "0");
            }

            deviceService.serialize();
            console.log("cmdAppAlert: " + $scope.device.appAlert);
        };

        $scope.onClickAlertTime = function () {
            if (currentPlatform == 'ios' || currentPlatform == 'android') {
                bleService.setOption($scope.device.id, "cmdAlertTime", $scope.device.alertTime);
            }
            deviceService.serialize();
            console.log("cmdAlertTime: " + $scope.device.alertTime);
                
        };

        $scope.onClickAlertRange = function() {
            if (currentPlatform == 'ios' || currentPlatform == 'android') {
                bleService.setOption($scope.device.id, "cmdAlertRange", $scope.device.alertRange);
            }

            deviceService.serialize();
            console.log("cmdAlertRange: " + $scope.device.alertRange);
        };

        $scope.AlertOnClickConfig  = function (){
            $state.go("config",{
                id:$stateParams.deviceId
            });
        };
        $scope.onClickReconnectAlert = function () {
            if (currentPlatform == 'ios' || currentPlatform == 'android') {
                bleService.setOption($scope.device.id, "cmdReconnectAlert", $scope.device.reconnectAlert ? "1" : "0");
            }

            deviceService.serialize();
            console.log("cmdReconnectAlert: " + $scope.device.reconnectAlert);
        };

        $scope.onClickItemAlert = function () {
            if (currentPlatform == 'ios' || currentPlatform == 'android') {
                bleService.setOption($scope.device.id, "cmdItemAlert", $scope.device.itemAlert ? "1" : "0");
            }

            deviceService.serialize();
            console.log("cmdItemAlert: " + $scope.device.itemAlert);
        };
    });
