angular.module('ufind1.controllers')

    .controller('bondCtrl', function ($rootScope, $scope, $state, $ionicActionSheet, $stateParams, $ionicLoading, $timeout, $ionicPopup, $translate,$ionicPopover, cameraService, serviceImagePicker, bleService, deviceService, itemService,systemService) {
        var currentPlatform = ionic.Platform.platform();
        var sys_tem = systemService.all();
        window.keyskeyid="";
        $scope.cameraimage = "img/photo.png";
        $scope.item_name = {name: ""};
        $scope.backtoypper  = function (){
            $state.go("main");
        };
        $scope.onClicktakePhoto = function () {
            $ionicActionSheet.show({
                buttons: [
                    {
                        text: '<i class="icon ion-share"></i> 从相册中选择'
                    },
                    {
                        text: '<i class="icon ion-arrow-move"></i> 拍照'
                    }
                ],
                cancelText: 'Cancel',
                cancel: function () {
                },
                buttonClicked: function (index) {
                    if (index == 0) {
                        if (currentPlatform == "android") {
                            var cameraOptions = {
                                maximumImagesCount: 1,
                                width: 100,
                                height: 100,
                                allowEdit: true,
                                quality: 100
                            };
                            serviceImagePicker.getPictures(cameraOptions).then(function (imageData) {
                                $scope.cameraimage = imageData;
                            }, function (err) {
                            });
                        } else if(currentPlatform == "ios"){
                            var cameraOptions = {
                                quality: 100,
                                destinationType: Camera.DestinationType.FILE_URI,
                                sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                                allowEdit: true,
                                encodingType: Camera.EncodingType.JPEG,
                                targetWidth: 300,
                                targetHeight: 300,
                                mediaType: 0,
                                cameraDirection: 0,
                                popoverOptions: CameraPopoverOptions,
                                saveToPhotoAlbum: true
                            };
                            cameraService.getPicture(cameraOptions).then(function (imageData) {
                                $scope.cameraimage = imageData;
                            }, function (err) {
                            });
                        }
                    } else if (index == 1) {
                        var cameraOptions = {
                            quality: 100,
                            destinationType: Camera.DestinationType.FILE_URI,
                            sourceType: Camera.PictureSourceType.CAMERA,
                            allowEdit: true,
                            encodingType: Camera.EncodingType.JPEG,
                            targetWidth: 300,
                            targetHeight: 300,
                            mediaType: 0,
                            cameraDirection: 0,
                            popoverOptions: CameraPopoverOptions,
                            saveToPhotoAlbum: true
                        };

                        cameraService.getPicture(cameraOptions).then(function (imageData) {
                            $scope.cameraimage = imageData;
                        }, function (err) {
                        });

                    }
                    return true;
                },
                destructiveButtonClicked: function () {
                    return true;
                }
            });
        };
        $scope.onClickedButtonKey = function () {
            $scope.button_key_color = "button-positive";
            $scope.button_wallet_color = "";
            $scope.button_notebook_color = "";
            $scope.button_case_color = "";
            $scope.button_bag_color = "";
            $scope.button_other_color = "";
            $scope.item_name.name = $translate.instant('bond_key',"","","");
        };

        $scope.onClickedButtonWallet = function () {
            $scope.button_key_color = "";
            $scope.button_wallet_color = "button-positive";
            $scope.button_notebook_color = "";
            $scope.button_case_color = "";
            $scope.button_bag_color = "";
            $scope.button_other_color = "";
            $scope.item_name.name = $translate.instant('bond_wallet',"","","");
        };

        $scope.onClickedButtonNotebook = function () {
            $scope.button_key_color = "";
            $scope.button_wallet_color = "";
            $scope.button_notebook_color = "button-positive";
            $scope.button_case_color = "";
            $scope.button_bag_color = "";
            $scope.button_other_color = "";
            $scope.item_name.name = $translate.instant('bond_computer',"","","");
        };

        $scope.onClickedButtonCase = function () {
            $scope.button_key_color = "";
            $scope.button_wallet_color = "";
            $scope.button_notebook_color = "";
            $scope.button_case_color = "button-positive";
            $scope.button_bag_color = "";
            $scope.button_other_color = "";
            $scope.item_name.name = $translate.instant('bond_suitcase',"","","");
        };

        $scope.onClickedButtonBag = function () {
            $scope.button_key_color = "";
            $scope.button_wallet_color = "";
            $scope.button_notebook_color = "";
            $scope.button_case_color = "";
            $scope.button_bag_color = "button-positive";
            $scope.button_other_color = "";
            $scope.item_name.name = $translate.instant('bond_satchel',"","","");
        };

        $scope.onClickedButtonOther = function () {
            $scope.button_key_color = "";
            $scope.button_wallet_color = "";
            $scope.button_notebook_color = "";
            $scope.button_case_color = "";
            $scope.button_bag_color = "";
            $scope.button_other_color = "button-positive";
            $scope.item_name.name = $translate.instant('bond_other',"","","");
        };

        $scope.onClickFinishBond = function (device) {
            device = $stateParams.device;
            $scope.itemSelecte=$scope.heightOption.itemSelected;
            if($scope.itemSelecte==0){
                $scope.onClickedButtonKey();
            }
            if($scope.itemSelecte==1){
                $scope.onClickedButtonWallet();
            }
            if($scope.itemSelecte==2){
                $scope.onClickedButtonNotebook();
            }
            if($scope.itemSelecte==3){
                $scope.onClickedButtonCase();
            }
            if($scope.itemSelecte==4){
                $scope.onClickedButtonBag();
            }
            if($scope.itemSelecte==5){
                $scope.onClickedButtonOther();
            }
            if (currentPlatform == 'ios' || currentPlatform == 'android') {
                bleService.setOption(device.id, "cmdAppAlert", device.appAlert ? "1" : "0");
                bleService.setOption(device.id, "cmdAlertTime", device.alertTime);
                bleService.setOption(device.id, "cmdAlertRange", device.alertRange);
                bleService.setOption(device.id, "cmdReconnectAlert", device.reconnectAlert ? "1" : "0");
                bleService.setOption(device.id, "cmdItemAlert", device.itemAlert ? "1" : "0");
            }
            var saveDeviceInfo = function (device) {
                device.imageURI = $scope.cameraimage;
                if($scope.item_name.name == "" || $scope.item_name.name == undefined || $scope.item_name.name == null ){
                    $scope.item_name.name="未命名";
                }
                device.name = $scope.item_name.name;
                $scope.deviceId=device.id;
                deviceService.add(device);
                deviceService.serialize();
                if(sys_tem.booleanFirst ==1){
                    sys_tem.booleanFirst =2;
                    systemService.serialize();
                }
                    bleService.setOption($scope.deviceId, "selfTakepicture", "0" + "" + device.zeroButton);
                    bleService.setOption($scope.deviceId, "selfTakepicture", "1" + "" + device.oneButton);
                    bleService.setOption($scope.deviceId, "selfTakepicture", "2" + "" + device.twoButton);
                    bleService.setOption($scope.deviceId, "selfTakepicture", "3" + "" + device.threeButton);
                    bleService.setOption($scope.deviceId, "selfTakepicture", "4" + "" + device.fourButton);
                    bleService.setOption($scope.deviceId, "selfTakepicture", "5" + "" + device.fiveButton);
                    bleService.setOption($scope.deviceId, "selfTakepicture", "6" + "" + device.sixButton);
                    bleService.setOption($scope.deviceId, "selfTakepicture", "7" + "" + device.sevenButton);
                    bleService.setOption($scope.deviceId, "selfTakepicture", "8" + "" + device.eightButton);
                $state.go("main");
            };

            $ionicLoading.show({
                template: '<ion-spinner icon="ios"></ion-spinner>',
                duration: 15 * 1000
            });
            if (typeof(cordova) != "undefined") {
                bleService.connect(device.id).promise.then(function (result) {
                }, function (result) {
                }, function (result) {
                    if (result.status == "connected") {
                        saveDeviceInfo(device);
                        $rootScope.onConnected(device);
                        $rootScope.$broadcast('devices.refresh', null);
                        $ionicLoading.hide();
                    } else if (result.status == "disconnected") {

                        if (result.lose_water != null || result.out_range != null) {
                            return;
                        } else {
                            $rootScope.onDisconnected(device);
                        }
                    } else {
                        $ionicLoading.hide();
                        $ionicPopup.alert({
                            title : $translate.instant("connect_message"),
                            template : '<p style="text-align:center">' + $translate.instant(result) + '</p>'
                        });
                    }
                })
            }
        };
        var brower = {
            versions:function(){
                var u = window.navigator.userAgent;
                var num ;
              if(u.indexOf('Mobile') > -1){
                  if(u.indexOf('Android') > -1 || u.indexOf('Linux') > -1){
                        //android
                //        num = u.substr(u.indexOf('Android') + 8, 3);
                      num = u.indexOf('Android');
                        return {"type":"Android", "version": num};
                    }
                }
            }
        }
        brower.versions();

        $scope.heightOption = {
            itemList: [],
            itemSelected:2
        };
        $scope.heightOption.itemList.push( $translate.instant('bond_key',"","",""));
        $scope.heightOption.itemList.push( $translate.instant('bond_wallet',"","",""));
        $scope.heightOption.itemList.push( $translate.instant('bond_computer',"","",""));
        $scope.heightOption.itemList.push( $translate.instant('bond_suitcase',"","",""));
        $scope.heightOption.itemList.push( $translate.instant('bond_satchel',"","",""));
        $scope.heightOption.itemList.push( $translate.instant('bond_other',"","",""));
        $scope.updateLanguages = function (optionSelected) {
        };
    });
