angular.module('ufind1.controllers')

    .controller('keyCtrl', function ($scope, $state, $stateParams, deviceService, actionService) {
        $scope.peripheral = deviceService.get($stateParams.deviceId);


        var keys = [ $scope.peripheral.zeroButton, $scope.peripheral.oneButton, $scope.peripheral.twoButton, $scope.peripheral.threeButton,
            $scope.peripheral.fourButton, $scope.peripheral.fiveButton, $scope.peripheral.sixButton, $scope.peripheral.sevenButton, $scope.peripheral.eightButton];
        window.keyidtempvalue="";
        $scope.onClickMain = function () {
            $state.go("config",{
                id:$stateParams.deviceId
            });
        };
        if (typeof($scope.peripheral.keys) === 'undefined') {
            $scope.peripheral.keys = keys;
            $scope.keys = keys;
        } else {
            $scope.keys = keys;
            console.log(JSON.stringify($scope.peripheral.keys));
        }
        $scope.getKeyActionImage = function (keyId) {
            return actionService.get($scope.keys[keyId]).img;
        };
        $scope.getKeyActionId = function (keyId) {
            if(keyId == 0){
                return 'Add_Key';
            }
            else if(keyId == 1){
                return 'Middle_Key';
            }
            else  if(keyId == 2){
                return 'Minus_Key';
            }
            if(keyId == 3){
                return 'double_Add_Key';
            }
            else if(keyId == 4){
                return 'double_Middle_Key';
            }
            else  if(keyId == 5){
                return 'double_Minus_Key';
            }
            if(keyId == 6){
                return 'longpress_Add_Key';
            }
            else if(keyId == 7){
                return 'longpress_Middle_Key';
            }
            else  if(keyId == 8){
                return 'longpress_Minus_Key';
            }
        };

        $scope.onClickKey = function (keyId) {
            keyidtempvalue=keyId;
            if(keyId==7){
            }else
                $state.go("action", {
               deviceId: $stateParams.deviceId,
               keyId: keyId
            });
        };
    });