angular.module('ufind1.services.action', ['pascalprecht.translate'])

.factory('actionService', function($translate) {
        if (currentPlatform == "android"){
            var actions = [{
                id: 0,
                img: 'img/action_not_set.png',
                txt: $translate.instant('action_not_set',"","","")
            }, {
                id: 1,
                img: 'img/action_alert.png',
                txt: $translate.instant('action_alert',"","","")
            },{
                id: -1,
                img: 'img/action_notsetmiddle.png',
                txt: '未设置'
            },{
                id: -2,
                img: 'img/action_notset.png',
                txt: '未设置'
            },{
                id: -3,
                img: 'img/action_not_settt.png',
                txt:  $translate.instant('action_not_settt',"","","")
            }, {

                id: 2,
                img: 'img/action_camera.png',
                txt:  $translate.instant('action_camera',"","","")
            }, {
                id: 3,
                img:  'img/action_simu_call.png',
                txt:  $translate.instant('action_simu_call',"","","")
            }, {
                id: 4,
                img: 'img/action_send_msg.png',
                txt:$translate.instant('action_send_msg',"","","")
            },
                {
                    id: 5,
                    img: 'img/action_make_call.png',
                    txt:$translate.instant('action_make_call',"","","")
                }, {
                    id: 6,
                    img: 'img/action_back.png'  ,
                    txt:$translate.instant('action_back',"","","")
                }, {
                    id: 7,
                    img: 'img/action_mute.png',
                    txt:$translate.instant('action_mute',"","","")
                }, {
                    id: 8,
                    img: 'img/action_vol_dec.png',
                    txt:$translate.instant('action_vol_dec',"","","")
                }, {
                    id: 9,
                    img: 'img/action_vol_inc.png',
                    txt:$translate.instant('action_vol_inc',"","","")
                }, {
                    id: 10,
                    img: 'img/action_homekey.png',
                    txt: $translate.instant('action_homekey',"","","")
                }, {
                    id: 11,
                    img: 'img/action_torch.png',
                    txt:$translate.instant('action_torch',"","","")
                }, {
                    id: 12,
                    img: 'img/action_take_photo.png',
                    txt: $translate.instant('action_take_photo',"","","")

                }, {
                    id: 13,
                    img: 'img/action_record_voice.png',
                    txt:  $translate.instant('action_record_voice',"","","")
                },
                {
                    id:14,
                    img:'img/action_record_video.png',
                    txt: $translate.instant('action_record_video',"","","")
                }, {
                    id: 15,
                    img: 'img/action_screen_shot.png',
                    txt:  $translate.instant('action_screen_shot',"","","")

                }, {
                    id: 16,
                    img: 'img/action_stop.png',
                    txt: $translate.instant('action_stop',"","","")
                }, {
                    id: 17,
                    img: 'img/action_play_pause.png',
                    txt: $translate.instant('action_play_pause',"","","")
                }, {
                    id: 18,
                    img: 'img/action_prev.png',
                    txt: $translate.instant('action_prev',"","","")
                }, {
                    id: 19,
                    img: 'img/action_pause.png',
                    txt:$translate.instant('action_pause',"","","")
                }, {
                    id: 20,
                    img: 'img/action_play.png',
                    txt: $translate.instant('action_play',"","","")
                }, {
                    id: 21,
                    img: 'img/action_next.png',
                    txt:  $translate.instant('action_next',"","","")
                }];
        }else if (currentPlatform == "ios"){
            var actions = [{
                id: 0,
                img: 'img/action_not_set.png',
                txt: $translate.instant('action_not_set',"","","")
            }, {
                id: 1,
                img: 'img/action_alert.png',
                txt: $translate.instant('action_alert',"","","")
            },{
                id: -1,
                img: 'img/action_notsetmiddle.png',
                txt: '未设置'
            },{
                id: -2,
                img: 'img/action_notset.png',
                txt: '未设置'
            },{
                id: -3,
                img: 'img/action_not_settt.png',
                txt:  $translate.instant('action_not_settt',"","","")
            }, {

                id: 2,
                img: 'img/action_camera.png',
                txt:  $translate.instant('action_camera',"","","")
            },{
                id: 3,
                img: 'img/action_play_pause.png',
                txt: $translate.instant('action_play_pause')
            },{
                id: 4,
                img: 'img/action_next.png',
                txt:  $translate.instant('action_next')
            }, {
                id: 5,
                img: 'img/action_prev.png',
                txt: $translate.instant('action_prev')
            }];
        }

	return {
		all: function() {
			return actions;
		},
		get: function(actionId) {
			for (var i = 0; i < actions.length; i++) {
				if (actions[i].id === parseInt(actionId)) {
					return actions[i];
				}
			}
		}
	};
});

