angular.module('ufind1.services.faq', ['pascalprecht.translate'])

.factory('faqService', function($translate) {
	var faqs = [{
		id: 0,
		name: $translate.instant('faqs_0_name'),
		lastText: $translate.instant('faqs_0_lastText')
	}, {
		id: 1,
		name: $translate.instant('faqs_1_name'),
		lastText: $translate.instant('faqs_1_lastText')
	}, {
		id: 2,
		name: $translate.instant('faqs_2_name'),
		lastText: $translate.instant('faqs_2_lastText')
	}, {
		id: 3,
		name: $translate.instant('faqs_3_name'),
		lastText: $translate.instant('faqs_3_lastText')
	}, {
		id: 5,
		name: $translate.instant('faqs_5_name'),
		lastText: $translate.instant('faqs_5_lastText')
	}, {
		id: 6,
		name: $translate.instant('faqs_6_name'),
		lastText: $translate.instant('faqs_6_lastText')
	}, {
		id: 7,
		name: $translate.instant('faqs_7_name'),
		lastText: $translate.instant('faqs_7_lastText')
	}, {
		id: 8,
		name: $translate.instant('faqs_8_name'),
		lastText: $translate.instant('faqs_8_lastText')
	}, {
		id: 9,
		name: $translate.instant('faqs_9_name'),
		lastText: $translate.instant('faqs_9_lastText')
	}];

	return {
		all: function() {
			return faqs;
		},
		get: function(chatId) {
			for (var i = 0; i < faqs.length; i++) {
				if (faqs[i].id === parseInt(chatId)) {
					return faqs[i];
				}
			}
			return null;
		}
	};
});